Index: soft/giet_vm/giet_fat32/fat32.c
===================================================================
--- soft/giet_vm/giet_fat32/fat32.c	(revision 569)
+++ soft/giet_vm/giet_fat32/fat32.c	(revision 587)
@@ -495,266 +786,307 @@
     unsigned int eof          = 0;
 
-    while ( (dir_entry_offset != DIR_ENTRY_SIZE)  && (!eof) )
+    while ( (buffer_offset != DIR_ENTRY_SIZE)  && (!eof) )
     {
         while (j != l_name_1 && !eof )
         {
-            if ( (dir_entry[dir_entry_offset] == 0x00) || 
-                 (dir_entry[dir_entry_offset] == 0xFF) )
+            if ( (buffer[buffer_offset] == 0x00) || 
+                 (buffer[buffer_offset] == 0xFF) )
             {
                 eof = 1;
                 continue;
             }
-            entry_name[entry_name_offset] = dir_entry[dir_entry_offset];
-            dir_entry_offset += 2;
+            name[name_offset] = buffer[buffer_offset];
+            buffer_offset += 2;
             j += 2;
-            entry_name_offset++;
-        }
-
-        dir_entry_offset += (l_attr + l_type + l_chksum);
+            name_offset++;
+        }
+
+        buffer_offset += (l_attr + l_type + l_chksum);
         j = 0;
 
         while (j != l_name_2 && !eof )
         {
-            if ( (dir_entry[dir_entry_offset] == 0x00) || 
-                 (dir_entry[dir_entry_offset] == 0xFF) )
+            if ( (buffer[buffer_offset] == 0x00) || 
+                 (buffer[buffer_offset] == 0xFF) )
             {
                 eof = 1;
                 continue;
             }
-            entry_name[entry_name_offset] = dir_entry[dir_entry_offset];
-            dir_entry_offset += 2;
+            name[name_offset] = buffer[buffer_offset];
+            buffer_offset += 2;
             j += 2;
-            entry_name_offset++;
-        }
-
-        dir_entry_offset += l_rsvd;
+            name_offset++;
+        }
+
+        buffer_offset += l_rsvd;
         j = 0;
 
         while (j != l_name_3 && !eof )
         {
-            if ( (dir_entry[dir_entry_offset] == 0x00) || 
-                 (dir_entry[dir_entry_offset] == 0xFF) )
+            if ( (buffer[buffer_offset] == 0x00) || 
+                 (buffer[buffer_offset] == 0xFF) )
             {
                 eof = 1;
                 continue;
             }
-            entry_name[entry_name_offset] = dir_entry[dir_entry_offset];
-            dir_entry_offset += 2;
+            name[name_offset] = buffer[buffer_offset];
+            buffer_offset += 2;
             j += 2;
-            entry_name_offset++;
-        }
-    }
-    entry_name[entry_name_offset] = '\0';
-
-    return entry_name_offset;
+            name_offset++;
+        }
+    }
+    name[name_offset] = 0;
 } // end get_name_from_long()
 
-///////////////////////////////////////////////////////////////////////////////////
-// This function update a DIR_ENTRY, write a new value into a specific field 
-// (ex : DIR_FILE_SIZE, when we want update the file size after a fat_write)
-// Return 0 in case of success, > 0 if failure.
-///////////////////////////////////////////////////////////////////////////////////
-// TODO : make this function less complex
-///////////////////////////////////////////////////////////////////////////////////
-static inline 
-unsigned int _update_entry( unsigned int use_irq,
-                            unsigned int fd_id, 
-                            unsigned int field,
-                            unsigned int size,
-                            unsigned int value )
-{
-    char dir_entry[32];   // buffer to store a full directory_entry
-    char name_entry[14];  // buffer to store a 13 characters (partial) name
-    char file_name[256];  // buffer to store the name (not pathname) of the file
-
-    char sfn_string[12]  = {[0 ... 10] = ' ', '\0'};     // buffer Short File Name
-    unsigned int lba     = _fat.fd[fd_id].lba_dir_entry;  // Lba of file dir_entry
-    unsigned int is_sfn;         
-    unsigned int attr    = 0;                            // dir entry attribute
-    unsigned int ord     = 0;                            // dir entry sequence
-    unsigned int found   = 0;                            // name found
-    unsigned int offset  = 0;                            // offset in fat_cache
-    unsigned int i       = 0;
-    unsigned int nb_read = 0;
-
-    for ( i = 0 ; i < 32 ; i++ ) dir_entry[i]  = 0;
-    for ( i = 0 ; i < 14 ; i++ ) name_entry[i] = 0;
-    
-    // Get the name of the file.
-    while ( get_name_from_path( _fat.fd[fd_id].name, file_name, &nb_read ) )
-    {
-    }
-
-    // Format file_name to SFN format
-    is_sfn = is_short( file_name, sfn_string );
-
-    // access FAT
-    if ( _fat_ioc_access( use_irq,
-                          1,               // read
-                          lba, 
-                          (unsigned int)_fat.fat_cache,
-                          1 ) )            // one sector
-    {
-        _printf("\n[FAT ERROR] in _update_entry() cannot read sector %x\n", 
-                lba );
-        return 1;
-    }
-    _fat.cache_lba = lba;
-
-    // - the offset increment is an integer number of directory entry (32 bytes)
-    // - the exit condition is success (name found) or failure (end of directory) 
-    while ( !found )
-    {
-        attr = _read_entry( DIR_ATTR, _fat.fat_cache + offset, 0 );
-        ord  = _read_entry( LDIR_ORD, _fat.fat_cache + offset, 0 );
-
-        if ( is_sfn == 1 )		                       // searched name is short
-        {
-            if      ( (ord != FREE_ENTRY ) &&
-                    (ord != NO_MORE_ENTRY) &&
-                    (attr == ATTR_LONG_NAME_MASK) )    // LFN entry : skipped
+
+
+
+////////////////////////////////////////////////////////////
+static fat_inode_t* _allocate_one_inode( char*        name,
+                                         unsigned int is_dir,
+                                         unsigned int cluster,
+                                         unsigned int size, 
+                                         unsigned int count,
+                                         unsigned int dentry,
+                                         unsigned int cache_allocate )
+{
+    fat_inode_t* new_inode  = _malloc( sizeof(fat_inode_t) );
+
+    new_inode->parent   = NULL;                 // set by _add_inode_in_tree()
+    new_inode->next     = NULL;                 // set by _add_inode_in_tree()
+    new_inode->child    = NULL;                 // set by _add_inode_in_tree()
+    new_inode->cluster  = cluster;
+    new_inode->size     = size; 
+    new_inode->cache    = NULL;
+    new_inode->levels   = 0;
+    new_inode->count    = count;
+    new_inode->is_dir   = (is_dir != 0);
+    new_inode->dentry   = dentry;             
+
+    _strcpy( new_inode->name , name );  
+
+    if ( cache_allocate )
+    {
+        fat_cache_node_t* new_cache  = _malloc( sizeof(fat_cache_node_t) );
+
+        new_inode->cache    = new_cache;
+        new_inode->levels   = _get_levels_from_size( size );
+        
+        unsigned int index;
+        for ( index = 0 ; index < 64 ; index ++ )  new_cache->children[index] = NULL;
+    }
+
+    return new_inode;
+}   // end _allocate_one_inode()
+
+
+
+
+////////////////////////////////////////////////////
+static void _add_inode_in_tree( fat_inode_t*  child,
+                                fat_inode_t*  parent )
+{
+    child->parent = parent;
+    child->next   = parent->child;
+    parent->child = child;
+}   // end _add_inode-in_tree()
+
+
+
+
+//////////////////////////////////////////////////////////
+static void _remove_inode_from_tree( fat_inode_t*  inode )
+{
+    fat_inode_t*  current;
+    fat_inode_t*  prev = inode->parent->child;
+
+    if ( inode == prev )  // removed inode is first in its linked list
+    {
+        inode->parent->child = inode->next;
+    }
+    else                  // removed inode is not the first
+    {
+        for( current = prev->next ; current ; current = current->next )
+        {
+            if ( current == inode )
             {
-                offset     = offset + ((ord & 0xF) * DIR_ENTRY_SIZE);
-                continue;
+                prev->next = current->next;
             }
-            else if ( (attr != ATTR_LONG_NAME_MASK) && 
-                    (ord  != FREE_ENTRY) && 
-                    (ord  != NO_MORE_ENTRY ) )         // SFN entry : checked
+            prev = current;
+        }    
+    }    
+}  // end _delete_one_inode()
+
+
+
+
+//////////////////////////////////////////////////////////////////////
+static unsigned int _get_buffer_from_cache( fat_inode_t*        inode,
+                                            unsigned int        cluster_id,
+                                            fat_cache_desc_t**  desc )
+{
+    // get cache pointer and levels
+    fat_cache_node_t*   node;         // pointer on a 64-tree node
+    unsigned int        level;        // cache level
+
+    if ( inode == NULL )   // searched cache is the Fat-Cache
+    {
+        node   = _fat.fat_cache_root;
+        level  = _fat.fat_cache_levels;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_buffer_from_cache() : enters in FAT-Cache"
+        " for cluster_id = %d\n", cluster_id );
+#endif
+
+    }
+    else                   // searched cache is a File-Cache
+    {
+        node   = inode->cache;
+        level  = inode->levels;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_buffer_from_cache() : enters in File-Cache <%s>"
+        " for cluster_id = %d\n", inode->name , cluster_id );
+#endif
+
+    }
+
+    // search the 64-tree cache from top to bottom 
+    while ( level )
+    {
+        // compute child index at each level
+        unsigned int index = (cluster_id >> (6*(level-1))) & 0x3F;
+
+        if ( level == 1 )        // last level => children are cluster descriptors
+        {
+            fat_cache_desc_t* pdesc = (fat_cache_desc_t*)node->children[index];
+
+            if ( pdesc == NULL )      // miss 
             {
-                memcpy( dir_entry, _fat.fat_cache + offset, DIR_ENTRY_SIZE );    
+                // allocate one cluster descriptor and one 4K buffer
+                unsigned char* buf = _malloc( 4096 );
+                pdesc              = _malloc( sizeof(fat_cache_desc_t) );
+
+                // get missing cluster index lba
+                unsigned int lba;
+                unsigned int next;
+                unsigned int current = inode->cluster;
+                unsigned int count   = cluster_id;
+
+                if ( inode == NULL )      // searched cache is the Fat-Cache
+                {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_buffer_from_cache() : miss in FAT-Cache for cluster_id %d\n",
+        cluster_id );
+#endif
+                    lba = _fat.fat_lba + (cluster_id << 3);
+                }
+                else                      // searched cache is a File-Cache
+                {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_buffer_from_cache() : miss in File-Cache <%s> "
+        "for cluster_id %d\n", inode->name, cluster_id );
+#endif
+                    while ( count )
+                    { 
+                        if ( _get_fat_entry( current , &next ) ) return 1;
+                        current = next;
+                        count--;
+                    }
+                    lba = _cluster_to_lba( current );
+                }
+
+                // load one cluster (8 blocks) from block device
+                if ( _fat_ioc_access( 1,         // descheduling
+                                      1,         // to memory
+                                      lba,
+                                      (unsigned int)buf,
+                                      8 ) )
+                {
+                    _printf("\n[FAT ERROR] in _get_buffer_from_cache()"
+                            " : cannot access block device for lba = %x\n", lba );
+                    return 1;
+                }
+
+                // update cache and buffer descriptor
+                node->children[index] = pdesc;
+                pdesc->lba     = lba;
+                pdesc->buffer  = buf;
+                pdesc->dirty   = 0;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_buffer_from_cache() : buffer loaded from device"
+        " at vaddr = %x\n", (unsigned int)buf );
+#endif
             }
-            else if (ord == NO_MORE_ENTRY )            // end of directory : return
+
+            // return pdesc pointer
+            *desc = pdesc;
+
+            // prepare next iteration
+            level--;
+        }
+        else                      // not last level => children are 64-tree nodes
+        {
+            fat_cache_node_t* child = (fat_cache_node_t*)node->children[index];
+            if ( child == NULL )  // miss 
             {
-                _printf("\n[FAT ERROR] in _update_entry() : reaches end\n");
-                return 1;
+                // allocate a cache node if miss
+                child = (fat_cache_node_t*)_malloc( sizeof(fat_cache_node_t) );
+                node->children[index] = child;    
             }
-            else									   // free entry : skipped
-            {
-                offset = offset + DIR_ENTRY_SIZE;
-                continue;
-            }
-        }
-        else                                           // searched name is long
-        {
-            if      ( (attr == ATTR_LONG_NAME_MASK) && 
-                    (ord != FREE_ENTRY) &&
-                    (ord != NO_MORE_ENTRY) )           // LFN entry : checked
-            {
-                memcpy( dir_entry, _fat.fat_cache + offset, DIR_ENTRY_SIZE );    
-            }
-            else if ( (attr != ATTR_LONG_NAME_MASK) && 
-                    (ord  != FREE_ENTRY) && 
-                    (ord  != NO_MORE_ENTRY))		   // SFN entry : skipped
-            {
-                offset = offset + DIR_ENTRY_SIZE;
-                continue;
-            }
-            else if (ord == NO_MORE_ENTRY )			   // end of directory : return
-            {
-                _printf("\n[FAT ERROR] in _update_entry() reaches end\n");
-                return 1;
-            }
-            else                                       // free entry : skipped
-            {
-                offset = offset + DIR_ENTRY_SIZE;
-                continue;
-            }
-        }
-
-        // testing the name extracted from dir entry
-
-        if ( is_sfn == 1 )                             // searched name is short
-        {
-            get_name_from_short( dir_entry, name_entry );
-
-            if ( _strncmp( (char*)sfn_string, (char*)name_entry, 13 ) == 0 )
-            {
-                _write_entry(offset + field, size, _fat.fat_cache, value);
-                found = 1;
-            }
-            else								       // no matching : skip
-            {
-                offset = offset + DIR_ENTRY_SIZE;
-            }
-        }
-        else                                           // searched name is long
-        {
-            get_name_from_long( dir_entry, name_entry );
-
-            unsigned shift = ((ord & 0xf) - 1) * 13;
-            if ( _strncmp( (char*)(file_name + shift), 
-                           (char*)name_entry, 13 ) == 0 )
-            {
-                if ( (ord & 0xf) == 1 )
-                {
-                    offset = offset + DIR_ENTRY_SIZE;
-                    _write_entry(offset + field, size, _fat.fat_cache, value);
-                    found = 1;
-                }
-                offset = offset + DIR_ENTRY_SIZE;
-                continue;
-            }
-            else								       // no matching : skip
-            {
-                offset = offset + ((ord & 0xf) * DIR_ENTRY_SIZE) + DIR_ENTRY_SIZE;
-            }
-        }
-    }
-
-    // write block to FAT
-    if ( _fat_ioc_access( use_irq,
-                          0,                // write
-                          lba, 
-                          (unsigned int)_fat.fat_cache, 
-                          1 ) )             // one sector
-    {
-        _printf("\n[FAT ERROR] in _update_entry() cannot write sector %x\n", 
-                lba );
-        return 1;
-    }
+
+            // prepare next iteration
+            node = child;
+            level--;
+        }
+    } // end while
 
     return 0;
-} // end _update_entry()
-
-
-//////////////////////////////////////////////////////////////////////////////////
-// This function update the FS_INFO block:
-// last cluster allocated and number of free cluster. 
-// Return 0 in case of success, > 0 if failure.
-//////////////////////////////////////////////////////////////////////////////////
-static inline 
-unsigned int _update_fs_info( unsigned int use_irq )
-{
-    unsigned int lba = _fat.fs_info_lba;
-
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _update_fs_info()\n");
-#endif
-
-    // update FAT cache in case of miss
-    if ( lba != _fat.cache_lba )
-    {
-        if ( _fat_ioc_access( use_irq,
+}  // end _get_buffer_from_cache()
+
+
+
+
+/////////////////////////////////////
+static unsigned int _update_fs_info()
+{
+    // update buffer if miss
+    if ( _fat.fs_info_lba != _fat.block_buffer_lba )
+    {
+        if ( _fat_ioc_access( 1,                 // descheduling
                               1,                 // read
-                              lba, 
-                              (unsigned int)_fat.fat_cache, 
-                              1 ) )              // one sector
+                              _fat.fs_info_lba, 
+                              (unsigned int)_fat.block_buffer, 
+                              1 ) )              // one block
         {
             _printf("\n[FAT_ERROR] in _update_fs_info() cannot read block\n");
             return 1;
         }
-        _fat.cache_lba = lba;
-    }
-
-    _write_entry( FS_FREE_CLUSTER     , _fat.fat_cache, _fat.number_free_cluster );
-    _write_entry( FS_FREE_CLUSTER_HINT, _fat.fat_cache, _fat.last_cluster_allocated );
+        _fat.block_buffer_lba = _fat.fs_info_lba;
+    }
+
+    // update FAT buffer
+    unsigned int* ptr;
+    ptr  = (unsigned int*)(_fat.block_buffer + get_offset(FS_FREE_CLUSTERS) );
+    *ptr = _fat.free_clusters_number;
+
+    ptr  = (unsigned int*)(_fat.block_buffer + get_offset(FS_FREE_CLUSTER_HINT) );
+    *ptr = _fat.first_free_cluster;
    
     // write bloc to FAT
-    if ( _fat_ioc_access( use_irq,
+    if ( _fat_ioc_access( 1,                // descheduling
                           0,                // write
-                          lba,
-                          (unsigned int)_fat.fat_cache, 
-                          1 ) )             // one sector
+                          _fat.fs_info_lba,
+                          (unsigned int)_fat.block_buffer, 
+                          1 ) )             // one block
     {
         _printf("\n[FAT_ERROR] in _update_fs_info() cannot write block\n");
